package PureMessage::Database::Watchdog::TestConnect;

use strict;
use warnings;
use Carp;
use DBI;
use PureMessage::Database::Watchdog::MyLog;

sub new {
    my $class = shift;
    my $self = {};
   $self->{tryCount} = shift;
   $self->{sleep} = shift;
   $self->{dsn} = shift;
#    print "TesConnect:  $self->{dsn}\n";
    bless $self, $class;
    return $self;
}


sub test{
    my $self = shift;

    $self->{count} = 0;
    $self->{sumMsg} = '';

#    print "TesterIF test tryCount: $self->{tryCount}\n";
#    my $res = $self->process();
#    print "TesterIF test tryCount: " .$res. "\n";

    while( ($self->process()  == 0) &&
        ($self->{count} < $self->{tryCount} ) ){
        mylog_info( $self->message() );
        sleep $self->{sleep};
        $self->{count}++;
    }
    if( $self->{count} == $self->{tryCount} ){
        return 0; # failed
    }
    return 1; # OK
}

sub process{
    my $self = shift;

    my $dsn = $self->{dsn};
    my $dbh = DBI->connect($dsn, "", "",
                              {
                                  RaiseError => 0,
                                  PrintError => 0,
                                  AutoCommit => 0,
                              });
        # or croak ("Could not connect to database with dsn \"$dsn\": $!");
    $self->{dbh} = $dbh;
    if($dbh){
      return 1;
    }
    return 0;

}

sub getMsg{
  my $self = shift;
  return $self->{sumMsg};
}

sub getDbh{
  my $self = shift;
  return  $self->{dbh};
}

sub message{
    my $self = shift;
    my $count = $self->{count} + 1;
    return "Could not connect to database! Try Count: ". $count. " ";
}
1;
