package PureMessage::Database::Watchdog::TestPing;

use strict;
use warnings;
use Carp;
#use Net::Ping;
use PureMessage::Database::Watchdog::MyLog;

sub new {
    my $class = shift;
    my $self = {};
   $self->{tryCount} = shift;
   $self->{sleep} = shift;
   $self->{host} = shift;
#    print "TesConnect:  $self->{dsn}\n";
    bless $self, $class;
    return $self;
}


sub test{
    my $self = shift;

    $self->{count} = 0;
    $self->{sumMsg} = '';

#    print "TesterIF test tryCount: $self->{tryCount}\n";
#    my $res = $self->process();
#    print "TesterIF test tryCount: " .$res. "\n";

    while( ($self->process()  == 0) &&
        ($self->{count} < $self->{tryCount} ) ){
        mylog_info( $self->message() );
        sleep $self->{sleep};
        $self->{count}++;
    }
    if( $self->{count} == $self->{tryCount} ){
        return 0; # failed
    }
    return 1; # OK
}

sub process{
    my $self = shift;
    my $os = $^O;
    my $res;
    if($os eq 'solaris' ){
       $res = `ping  $self->{host} | grep alive | wc -l`;
   }else{
       $res = `ping -c 1 $self->{host} | grep icmp* | wc -l`;
   } 
    
#    print $command;
    if( $res == 1){
	return 1;
    }
    return 0;
}

#sub process{
#    my $self = shift;

#    my $p = Net::Ping->new("tcp");
#    my $res = $p->ping( $self->{host}, 2);
#    if($res){
#      print $res;
#      return 1;
#    }
#    return 0;
#}

sub getMsg{
  my $self = shift;
  return $self->{sumMsg};
}


sub message{
    my $self = shift;
    my $count = $self->{count} + 1;
    return "Could not ping host: " .$self->{host}. ". Try Count: ". $count. " ";
}
1;
