package PureMessage::Database::Watchdog::TestSelect;

use strict;
use warnings;
use Carp;
use DBI;
use PureMessage::Database::Watchdog::MyLog;

sub new {
    my $class = shift;
    my $self = {};
   $self->{tryCount} = shift;
   $self->{sleep} = shift;
   $self->{dbh} = shift;
    bless $self, $class;
    return $self;
}


sub test{
    my $self = shift;

    $self->{count} = 1;
    $self->{sumMsg} = '';

    while( ($self->process()  == 0) &&
        ($self->{count} < $self->{tryCount} ) ){
        sleep $self->{sleep};
        $self->{count}++;
    }
    if( $self->{count} == $self->{tryCount} ){
        return 0; # failed
    }
    return 1; # OK
}

sub process{
    my $self = shift;

    my $dbh = $self->{dbh};

    # execute SELECT query
    my $sth = $dbh->prepare("SELECT user_name, email FROM pmx_user");
    # bad select 
    # my $sth = $dbh->prepare("SELECT user_name, email FROM pmx_userx");
    my $res = $sth->execute();
    if(!$res){
        mylog_info("Could not execute select " .$sth->errstr. ": $!");
        return 0;
    }
    my $rows = $sth->rows;
    return 1;
}

sub getMsg{
  my $self = shift;
  return $self->{sumMsg};
}

sub getDbh{
  my $self = shift;
  return  $self->{dbh};
}

sub message{
    my $self = shift;
    my $count = $self->{count} + 1;
    return "Could not execute select! Try Count: ". $count. " ";
}
1;
